Index: /java/main/src/main/java/com/framsticks/model/Package.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Package.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/Package.java	(revision 86)
@@ -8,14 +8,15 @@
 public class Package {
 	public static void register(Registry registry) {
-		registry.registerReflectedClass("MechPart", null, "com.framsticks.model.MechPart");
-		registry.registerReflectedClass("Joint", "j", "com.framsticks.model.Joint");
-		registry.registerReflectedClass("MechJoint", null, "com.framsticks.model.MechJoint");
-		registry.registerReflectedClass("Neuro", null, "com.framsticks.model.Neuro");
-		registry.registerReflectedClass("NeuroDef", "n", "com.framsticks.model.NeuroDef");
-		registry.registerReflectedClass("Part", "p", "com.framsticks.model.Part");
-		registry.registerReflectedClass("Model", "m", "com.framsticks.model.Model");
-		registry.registerReflectedClass("Creature", null, "com.framsticks.model.Creature");
-		registry.registerReflectedClass("Genotype", null, "com.framsticks.model.Genotype");
-
+		registry
+			.register(MechPart.class)
+			.register(Joint.class)
+			.register(MechJoint.class)
+			.register(Neuro.class)
+			.register(NeuroDef.class)
+			.register(Part.class)
+			.register(Model.class)
+			.register(Creature.class)
+			.register(Genotype.class)
+			.register(World.class);
 	}
 }
Index: /java/main/src/main/java/com/framsticks/model/Part.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/Part.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/Part.java	(revision 86)
@@ -2,4 +2,6 @@
 
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.math.Point3d;
 
@@ -7,41 +9,34 @@
  * The Class Part.
  */
+@FramsClassAnnotation(id = "p")
 public class Part extends BasePart {
 
-	/** rx, ry, rz*/
+	@ParamAnnotation
 	public double rx, ry, rz;
+
 
 	public Point3d getRotation() { return new Point3d(rx, ry, rz); }
 	public void setRotation(Point3d r) { rx = r.x; ry = r.y; rz = r.z; }
 
-	/** dn */
-	public Double density;
+	@ParamAnnotation(id = "dn")
+	public double density;
 
-	/** ing */
-	public Double ingestion;
+	@ParamAnnotation(id = "ing")
+	public double ingestion;
 
-	/** as */
-	public Double assimilation;
+	@ParamAnnotation(id = "as")
+	public double assimilation;
 
-	/** i */
+	@ParamAnnotation(id = "i")
 	public String info;
 
-	/** Vstyle */
+	@ParamAnnotation(id = "Vstyle")
 	public String visualizationStyle;
 
-	public Double getDn() { return density; }
-	public void setDn(Double dn) { density = dn; }
+	@ParamAnnotation(id = "vs")
+	public double visualThickness;
 
-	public Double getIng() { return ingestion; }
-	public void setIng(Double ing) { ingestion = ing; }
-
-	public Double getAs() { return assimilation; }
-	public void setAs(Double as) { assimilation = as; }
-
-	public String getI() { return info; }
-	public void setI(String i) { info = i; }
-
-	public String getVstyle() { return visualizationStyle; }
-	public void setVstyle(String vstyle) { visualizationStyle = vstyle; }
+	@ParamAnnotation
+	public double vr, vg, vb;
 
 }
Index: /java/main/src/main/java/com/framsticks/model/World.java
===================================================================
--- /java/main/src/main/java/com/framsticks/model/World.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/model/World.java	(revision 86)
@@ -1,11 +1,37 @@
 package com.framsticks.model;
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
 public class World {
 
-	public Integer wrldbnd;
-	public Double wrldwat;
-	public String faces;
+	@ParamAnnotation(id = "wrldbnd")
+	public int boundaries;
+
+	@ParamAnnotation(id = "wrldwat")
+	public double waterLevel;
 
 
+	@ParamAnnotation(id = "wrldtyp")
+	public int type;
+
+	@ParamAnnotation(id = "wrldsiz")
+	public double size;
+
+	@ParamAnnotation(id = "wrldmap")
+	public String map;
+
+	@ParamAnnotation(id = "wrldg")
+	public double gravity;
+
+	@ParamAnnotation(id = "simtype")
+	public int simulationEngine;
+
+	@ParamAnnotation(id = "nnspeed")
+	public double neuralNetworkSimulationSpeed;
+
+	@ParamAnnotation
+	public String faces;
 	/*
 	public static ReflectionAccess createReflection()
Index: /java/main/src/main/java/com/framsticks/observers/Endpoint.java
===================================================================
--- /java/main/src/main/java/com/framsticks/observers/Endpoint.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/observers/Endpoint.java	(revision 86)
@@ -4,5 +4,6 @@
 import com.framsticks.core.InstanceListener;
 import com.framsticks.core.Path;
-import com.framsticks.params.FramsClass;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.core.ListChange;
 import com.framsticks.util.dispatching.Dispatcher;
@@ -13,9 +14,13 @@
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public class Endpoint implements Dispatcher<Instance>, InstanceListener {
 	private final static Logger log = Logger.getLogger(Endpoint.class.getName());
 
+	@ParamAnnotation
 	protected Instance instance;
 	protected Observer observer;
+
+	@ParamAnnotation
 	protected String name;
 
@@ -80,7 +85,4 @@
 	}
 
-	public static void constructFramsClass(FramsClass.Constructor constructor) {
-		constructor.method("getName").method("getInstance");
-	}
 
 }
Index: /java/main/src/main/java/com/framsticks/observers/Observer.java
===================================================================
--- /java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/observers/Observer.java	(revision 86)
@@ -4,5 +4,6 @@
 import com.framsticks.core.Instance;
 import com.framsticks.core.Program;
-import com.framsticks.params.FramsClass;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.lang.Casting;
 import org.apache.commons.configuration.Configuration;
@@ -14,4 +15,5 @@
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation
 public abstract class Observer extends Entity {
 
@@ -21,4 +23,5 @@
 	}
 
+	@ParamAnnotation
 	protected final Map<String, Endpoint> endpoints = new HashMap<String, Endpoint>();
 
@@ -68,7 +71,4 @@
 	}
 
-	public static void constructFramsClass(FramsClass.Constructor constructor) {
-		constructor.method("getEndpoints");
-	}
 
 
Index: /java/main/src/main/java/com/framsticks/params/AccessInterface.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/AccessInterface.java	(revision 86)
@@ -66,5 +66,5 @@
 	Object getSelected();
 
-	AccessInterface cloneAccess();
+	AccessInterface cloneAccess() throws ConstructionException;
 
 	Object createAccessee();
Index: /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/ArrayListAccess.java	(revision 86)
@@ -20,5 +20,5 @@
 
 	@Override
-	public ArrayListAccess cloneAccess() {
+	public ArrayListAccess cloneAccess() throws ConstructionException {
 		return new ArrayListAccess(elementAccess.cloneAccess());
 	}
Index: /java/main/src/main/java/com/framsticks/params/ConstructionException.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ConstructionException.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/ConstructionException.java	(revision 86)
@@ -0,0 +1,8 @@
+package com.framsticks.params;
+
+import com.framsticks.util.FramsticksException;
+
+@SuppressWarnings("serial")
+public class ConstructionException extends FramsticksException {
+
+}
Index: /java/main/src/main/java/com/framsticks/params/FramsClass.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/FramsClass.java	(revision 86)
@@ -1,14 +1,11 @@
 package com.framsticks.params;
 
-import com.framsticks.params.types.StringParam;
-import com.framsticks.parsers.FileSource;
-import com.framsticks.parsers.Loaders;
-import com.framsticks.util.lang.Casting;
-
-import org.apache.log4j.Logger;
-
-import java.io.InputStream;
-import java.lang.reflect.*;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+// import com.framsticks.util.FramsticksException;
+
 import java.util.*;
+
+import javax.annotation.Nonnull;
 
 /**
@@ -24,12 +21,6 @@
  * @author Piotr Sniegowski
  */
+@FramsClassAnnotation(id = "class", name = "class")
 public final class FramsClass {
-
-	private final static Logger log = Logger.getLogger(FramsClass.class
-			.getName());
-
-	/**
-	 * The Class which represents group.
-	 */
 
 	/** The offset of the parameter (applied for newly added parameter). */
@@ -62,4 +53,5 @@
 
 	public FramsClass() {
+
 	}
 
@@ -77,4 +69,7 @@
 	 */
 	public FramsClass append(Param param) {
+		// if (param.hasFlag(Flags.USERHIDDEN)) {
+		// 	return this;
+		// }
 		paramEntryMap.put(param.getId(), param);
 		//paramEntryMap.put(param.getInternalId(), param);
@@ -104,4 +99,5 @@
 	}
 
+	@ParamAnnotation(id = "desc")
 	public String getDescription() {
 		return description;
@@ -130,9 +126,9 @@
 
 	/**
-	 * Gets the group getName.
+	 * Gets the group name.
 	 *
 	 * @param gi
 	 *            the offset of group
-	 * @return the group getName
+	 * @return the group name
 	 */
 	public String getGroupName(int gi) {
@@ -142,8 +138,10 @@
 	}
 
+	@ParamAnnotation
 	public String getId() {
 		return id;
 	}
 
+	@ParamAnnotation
 	public String getName() {
 		return name;
@@ -152,4 +150,16 @@
 	public String getNiceName() {
 		return name != null ? name : id;
+	}
+
+	public <T extends Param> T castedParam(@Nonnull final Param param, @Nonnull final Class<T> type, Object name) {
+		if (param == null) {
+			return null;
+			// throw new FramsticksException().msg("param is missing").arg("name", name).arg("in", this);
+		}
+		if (!type.isInstance(param)) {
+			return null;
+			// throw new FramsticksException().msg("wrong type of param").arg("actual", param.getClass()).arg("requested", type).arg("in", this);
+		}
+		return type.cast(param);
 	}
 
@@ -161,9 +171,6 @@
 	 * @return the param entry
 	 */
-	public <T extends Param> T getParamEntry(int i, Class<T> type) {
-		if (i < 0 || i >= paramList.size()) {
-			return null;
-		}
-		return Casting.tryCast(type, paramList.get(i));
+	public <T extends Param> T getParamEntry(final int i, @Nonnull final Class<T> type) {
+		return castedParam(getParam(i), type, i);
 	}
 
@@ -175,6 +182,20 @@
 	 * @return the param entry
 	 */
-	public <T extends Param> T getParamEntry(String id, Class<T> type) {
-		return Casting.tryCast(type, paramEntryMap.get(id));
+	public <T extends Param> T getParamEntry(@Nonnull final String id, @Nonnull final Class<T> type) {
+		return castedParam(getParam(id), type, id);
+	}
+
+	public Param getParam(int i) {
+		if (i < 0 || i >= paramList.size()) {
+			return null;
+		}
+		return paramList.get(i);
+	}
+
+	public Param getParam(String id) {
+		if (!paramEntryMap.containsKey(id)) {
+			return null;
+		}
+		return paramEntryMap.get(id);
 	}
 
@@ -188,143 +209,17 @@
 	}
 
-	public static FramsClass getFramsClass() {
-		return new FramsClass("class", "class", null)
-			.append(Param.build().id("name").name("Name").type(StringParam.class))
-			.append(Param.build().id("id").name("id").type(StringParam.class))
-			.append(Param.build().id("desc").name("Description").type(StringParam.class));
-	}
-
+	@ParamAnnotation
 	public void setId(String id) {
 		this.id = id;
 	}
 
+	@ParamAnnotation
 	public void setName(String name) {
 		this.name = name;
 	}
 
+	@ParamAnnotation(id = "desc")
 	public void setDescription(String description) {
 		this.description = description;
 	}
-
-	public static String getParamTypeForNativeType(Type type) {
-		if (type instanceof ParameterizedType) {
-			ParameterizedType p = (ParameterizedType) type;
-			Type rawType = p.getRawType();
-			if (rawType.equals(Map.class)) {
-				Type containedType = p.getActualTypeArguments()[1];
-				//TODO uid should be passed along during construction
-				if (containedType instanceof Class) {
-					return "l " + ((Class<?>) containedType).getCanonicalName()
-							+ " name";
-				}
-			}
-			if (rawType.equals(List.class)) {
-				Type containedType = p.getActualTypeArguments()[0];
-				if (containedType instanceof Class) {
-					return "l " + ((Class<?>) containedType).getCanonicalName();
-				}
-			}
-			return null;
-		}
-
-		if (type.equals(Integer.class)) {
-			return "d";
-		}
-		if (type.equals(String.class)) {
-			return "s";
-		}
-		if (type.equals(Double.class)) {
-			return "f";
-		}
-		if (type instanceof Class) {
-			return "o " + ((Class<?>) type).getCanonicalName();
-		}
-		return null;
-	}
-
-	public static final String GENERATE_HELP_PREFIX = "automatically generated from: ";
-
-	public static FramsClass readFromStream(InputStream stream) {
-		return Loaders.loadFramsClass(new FileSource(stream));
-	}
-
-	public static class Constructor {
-		protected final FramsClass result;
-		protected Class<?> currentClass;
-
-		public Constructor(Class<?> src, String name) {
-			result = new FramsClass(name, name, GENERATE_HELP_PREFIX
-					+ src.toString());
-			currentClass = src;
-			while (currentClass != null) {
-				try {
-					currentClass.getMethod("constructFramsClass", Constructor.class).invoke(null, this);
-				} catch (IllegalAccessException | IllegalArgumentException
-						| InvocationTargetException | NoSuchMethodException
-						| SecurityException e) {
-					log.debug("failed to use constructFramsClass static method (skipping): ", e);
-				}
-				currentClass = currentClass.getSuperclass();
-			}
-			currentClass = src;
-		}
-
-		public final FramsClass getResult() {
-			return result;
-		}
-
-		public Constructor allFields() {
-			for (Field f : currentClass.getFields()) {
-				field(f.getName());
-			}
-			return this;
-		}
-
-		public Constructor method(String name, Class<?> ... arguments) {
-			try {
-				Method method = currentClass.getMethod(name, arguments);
-				if (!Modifier.isPublic(method.getModifiers())) {
-					return this;
-				}
-				String returnParamClass = getParamTypeForNativeType(method.getGenericReturnType());
-				if (returnParamClass == null) {
-					return this;
-				}
-				Class<?>[] args = method.getParameterTypes();
-				if (args.length == 0) {
-					if (method.getName().startsWith("get")) {
-						String fieldName = method.getName().substring(3, 4).toLowerCase() + method.getName().substring(4);
-						Param param = Param.build().type(returnParamClass).name(fieldName).id(fieldName).help(GENERATE_HELP_PREFIX + method.toString()).finish();
-						assert param != null;
-						result.append(param);
-						return this;
-					}
-					return this;
-				}
-				return this;
-			} catch (NoSuchMethodException e) {
-				log.fatal("method " + name + " was not found in " + currentClass.toString());
-			}
-			return this;
-		}
-		public Constructor field(String name) {
-			try {
-				Field field = currentClass.getField(name);
-				if (!Modifier.isPublic(field.getModifiers())) {
-					return this;
-				}
-				String paramClass = getParamTypeForNativeType(field.getGenericType());
-				if (paramClass == null) {
-					return this;
-				}
-				Param param = Param.build().type(paramClass).name(field.getName()).id(field.getName()).help(GENERATE_HELP_PREFIX + field.toString()).finish();
-				assert param != null;
-				result.append(param);
-				return this;
-			} catch (NoSuchFieldException e) {
-				log.fatal("field " + name + " was not found in " + currentClass.toString());
-			}
-			return this;
-		}
-	}
 }
Index: /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/FramsClassBuilder.java	(revision 86)
@@ -0,0 +1,161 @@
+package com.framsticks.params;
+
+import java.io.InputStream;
+import java.lang.reflect.Field;
+import java.lang.reflect.Member;
+import java.lang.reflect.Method;
+import java.lang.reflect.ParameterizedType;
+import java.lang.reflect.Type;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.parsers.FileSource;
+import com.framsticks.parsers.Loaders;
+import com.framsticks.util.lang.Strings;
+
+public class FramsClassBuilder {
+	private static final Logger log =
+		Logger.getLogger(FramsClassBuilder.class);
+
+
+	public static String getName(FramsClassAnnotation fca, Class<?> javaClass) {
+		return fca.name().equals("") ? javaClass.getSimpleName() : fca.name();
+	}
+
+	public static String getId(FramsClassAnnotation fca, Class<?> javaClass) {
+		return fca.id().equals("") ? javaClass.getSimpleName() : fca.id();
+	}
+
+	public static String getParamTypeForNativeType(Type type) {
+		if (type instanceof ParameterizedType) {
+			ParameterizedType p = (ParameterizedType) type;
+			Type rawType = p.getRawType();
+			Type containedType = null;
+			//TODO make implementation here
+			boolean map = false;
+			if (rawType.equals(Map.class)) {
+				containedType = p.getActualTypeArguments()[1];
+				map = true;
+			} else if (rawType.equals(List.class)) {
+				containedType = p.getActualTypeArguments()[0];
+			}
+			if (!(containedType instanceof Class)) {
+				return null;
+			}
+			Class<?> containedClass = (Class<?>) containedType;
+			StringBuilder b = new StringBuilder();
+			b.append("l ");
+			FramsClassAnnotation fca = containedClass.getAnnotation(FramsClassAnnotation.class);
+			if (fca == null) {
+				log.error("the class is not annotated: " + containedClass);
+				return null;
+			}
+			b.append(getName(fca, containedClass));
+			if (map) {
+				b.append(" name");
+			}
+
+			return b.toString();
+		}
+
+		if (type.equals(Integer.class) || type.equals(int.class)) {
+			return "d";
+		}
+		if (type.equals(String.class)) {
+			return "s";
+		}
+		if (type.equals(Double.class) || type.equals(double.class)) {
+			return "f";
+		}
+		if (type.equals(Boolean.class) || type.equals(boolean.class)) {
+			return "d 0 1";
+		}
+		if (type.equals(Object.class)) {
+			return "x";
+		}
+		if (type instanceof Class) {
+			return "o " + ((Class<?>) type).getCanonicalName();
+		}
+		return null;
+	}
+
+	public static final String GENERATE_HELP_PREFIX = "automatically generated from: ";
+
+	public static FramsClass readFromStream(InputStream stream) {
+		return Loaders.loadFramsClass(new FileSource(stream));
+	}
+
+	// public static Class<? extends Param> getParamType(@Nonnull Class<?> c) {
+	//	if (c.equals(Integer.class)) {
+	//		return DecimalParam.class;
+	//	}
+	//	if (c.equals(Double.class)) {
+	//		return FloatParam.class;
+	//	}
+	//	if (c.equals(String.class)) {
+	//		return StringParam.class;
+	//	}
+	//	if (c.equals(Object.class)) {
+	//		return UniversalParam.class;
+	//	}
+	//	return null;
+	// }
+
+	public static String extractIdOf(Member member) {
+		if (member instanceof Field) {
+			return member.getName();
+		}
+		if (member instanceof Method) {
+			Method m = (Method) member;
+			String n = m.getName();
+			int argsNum = m.getParameterTypes().length;
+			if (argsNum == 0) {
+				return n.startsWith("get") ? Strings.uncapitalize(n.substring(3)) : n;
+			}
+			if (argsNum == 1) {
+				return n.startsWith("set") ? Strings.uncapitalize(n.substring(3)) : n;
+			}
+			log.error("invalid number of arguments");
+			return null;
+		}
+		log.error("invalid kind of member");
+		return null;
+	}
+	public static String getName(ParamAnnotation annotation, Member member) {
+		return annotation.name().equals("") ? Strings.capitalize(extractIdOf(member)) : annotation.name();
+	}
+
+	public static String getId(ParamAnnotation annotation, Member member) {
+		return annotation.id().equals("") ? extractIdOf(member) : annotation.id();
+	}
+
+	public static ParamBuilder fill(ParamBuilder builder, Member member, ParamAnnotation annotation) {
+		return builder
+			.id(getId(annotation, member))
+			.name(getName(annotation, member));
+
+	}
+
+	public static FramsClass buildForClass(Class<?> javaClass) throws ConstructionException {
+
+		FramsClassAnnotation fca = javaClass.getAnnotation(FramsClassAnnotation.class);
+		if (fca == null) {
+			log.error(javaClass.getName() + " is not annotated with FramsClassAnnotation");
+			return null;
+		}
+
+		FramsClass framsClass = new FramsClass(getId(fca, javaClass), getName(fca, javaClass), "");
+
+		Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(javaClass);
+
+		for (ParamCandidate pc : candidates.values()) {
+			framsClass.append(Param.build().id(pc.getId()).name(pc.getName()).type(getParamTypeForNativeType(pc.getType())).flags(pc.getFlags()));
+		}
+
+		return framsClass;
+	}
+}
Index: /java/main/src/main/java/com/framsticks/params/ListSource.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ListSource.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/ListSource.java	(revision 86)
@@ -1,4 +1,5 @@
 package com.framsticks.params;
 
+import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
@@ -7,19 +8,22 @@
 
 	private Iterator<String> iterator = null;
-    //private final List<String> source;
+	//private final List<String> source;
 
 	public ListSource(List<String> source) {
-        //this.source = source;
-        iterator = source.iterator();
+		//this.source = source;
+		iterator = source.iterator();
 	}
 
-    @Override
+	@Override
 	public String getFilename() {
 		return "<net>";
 	}
 
-    @Override
-    public String readLine() {
-        assert iterator != null;
+	@Override
+	public String readLine() {
+		// if (iterator == null) {
+		//	return null;
+		// }
+		assert iterator != null;
 		if (iterator.hasNext()) {
 			return iterator.next();
@@ -28,17 +32,30 @@
 	}
 
-    @Override
-    public String demangleInclude(String include) {
+	@Override
+	public String demangleInclude(String include) {
 		return null;
 	}
 
-    @Override
-    public SourceInterface openInclude(String include) {
+	@Override
+	public SourceInterface openInclude(String include) {
 		return null;
 	}
 
-    @Override
-    public void close() {
-        iterator = null;
+	@Override
+	public void close() {
+		iterator = null;
+	}
+
+	public static ListSource createFrom(String... lines) {
+		List<String> list = new ArrayList<String>();
+		for (String l : lines) {
+			list.add(l);
+		}
+		return new ListSource(list);
+	}
+
+	@Override
+	public boolean isClosed() {
+		return iterator == null;
 	}
 }
Index: /java/main/src/main/java/com/framsticks/params/ParamBuilder.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/ParamBuilder.java	(revision 86)
@@ -1,4 +1,6 @@
 package com.framsticks.params;
 
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.*;
 import com.framsticks.util.lang.Numbers;
@@ -8,4 +10,5 @@
 import java.util.ArrayList;
 import java.util.Arrays;
+
 
 /**
@@ -18,4 +21,5 @@
  */
 
+@FramsClassAnnotation(name = "prop", id = "prop")
 public class ParamBuilder {
 	private final static Logger log = Logger.getLogger(ParamBuilder.class.getName());
@@ -28,9 +32,9 @@
 	private static final String FLAGS_FIELD = "flags";
 
-	/** The parameter getId. */
+	/** The parameter id. */
 	private String id;
 
 	/**
-	 * The parameter internal getId. It's set by a user to use user's own getId in
+	 * The parameter internal id. It's set by a user to use user's own id in
 	 * code
 	 */
@@ -40,20 +44,21 @@
 	private Integer group = 0;
 
-	/** The getFlags stored as a bit sum. */
+	/** The flags stored as a bit sum. */
 	private Integer flags = 0;
 
-	/** The parameter getName. */
+	/** The parameter name. */
 	private String name;
 
-	/** The getHelp (description) concerning parameter. */
+	/** The help (description) concerning parameter. */
 	private String help;
 
-	/** The getType of parameter. */
+	/** The type of parameter. */
 	private Class<? extends Param> paramType;
 
 	private Param param;
 	private PrimitiveParam primitiveParam;
-
-	ParamBuilder() {
+	private String typeString;
+
+	public ParamBuilder() {
 	}
 
@@ -76,4 +81,5 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder id(String id) {
 		this.id = id;
@@ -87,8 +93,10 @@
 			primitiveParam = (PrimitiveParam) param;
 		}
+		typeString = param.getFramsTypeName();
 		return this;
 	}
 
 	public <T extends Param> ParamBuilder type(Class<T> type) {
+		assert type != null;
 		try {
 			return internalSetType(type, type.newInstance());
@@ -104,4 +112,12 @@
 
 
+	/**
+	 * @return the id
+	 */
+	@ParamAnnotation
+	public String getId() {
+		return id;
+	}
+
 	public ParamBuilder setInternalId(String internalId) {
 		this.internalId = internalId;
@@ -109,4 +125,5 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder group(Integer group) {
 		this.group = group;
@@ -114,4 +131,5 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder flags(Integer flags) {
 		this.flags = flags;
@@ -119,4 +137,5 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder name(String name) {
 		this.name = name;
@@ -143,5 +162,7 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder type(String type) {
+		typeString = type;
 
 		log.trace("parsing type: " + type);
@@ -233,7 +254,45 @@
 	}
 
+	@ParamAnnotation
 	public ParamBuilder help(String help) {
 		this.help = help;
 		return this;
+	}
+
+	/**
+	 * @return the group
+	 */
+	@ParamAnnotation
+	public Integer getGroup() {
+		return group;
+	}
+
+	/**
+	 * @return the flags
+	 */
+	@ParamAnnotation
+	public Integer getFlags() {
+		return flags;
+	}
+
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @return the help
+	 */
+	@ParamAnnotation
+	public String getHelp() {
+		return help;
+	}
+
+	@ParamAnnotation
+	public String getType() {
+		return typeString;
 	}
 
@@ -328,13 +387,4 @@
 
 
-	public static FramsClass getFramsClass() {
-		return new FramsClass("prop", "prop", null)
-			.append(Param.build().id("name").name("Name").type(StringParam.class))
-			.append(Param.build().id("id").name("Id").type(StringParam.class))
-			.append(Param.build().id("type").name("Type").type(StringParam.class))
-			.append(Param.build().id("help").name("Help").type(StringParam.class))
-			.append(Param.build().id("group").name("Group").type(DecimalParam.class))
-			.append(Param.build().id("flags").name("Flags").type(DecimalParam.class));
-	}
 
 }
